#!/usr/X11R6/bin/wish
#
# This script generates a counter with start and stop buttons.

load [info library]/libtclmod.so
source ~/subs/arsubs.tcl

set watchdog(maxtime)	25
set watchdog(file)		"[Exp_Config_Dir]/locks/AR.Busy"
set watchdog(running)	"[Exp_Config_Dir]/locks/AR.running"
set watchdog(left)		""

set varfile "armain.vars"
set varfile_modified 0

set listfile "armain.list"
set listfile_modified 0

set logfile "armain.log"
set logfile_modified 0
set logheight 10

set bigfont "-*-times-medium-r-*-*-25-*-*-*-*-*-*-*"
set midfont "-*-helvetica-medium-r-*-*-10-*-*-*-*-*-*-*"

set mux4_modified 0
set mux5_modified 0
set koax_modified 0

proc Tk_AutoRun_Init_MainMenu {} {
  frame .menu  -relief raised -borderwidth 2
    menubutton .menu.file    -text "File"    -underline 0 -menu .menu.file.items
      menu .menu.file.items
		.menu.file.items add separator
        .menu.file.items add command -label "Info" -underline 0 -command {puts "\n  1998, by J\"urgen Leib, Andi and Schuh"}
        .menu.file.items add separator
        .menu.file.items add command -label "Beenden" -underline 0 -command {remove_ar n;destroy .}

    global PLM

  # Binding of Menu ...
  tk_menuBar menu menu.file

  pack .menu -fill x -padx 1 -pady 1
  pack .menu.file -side left
  
  wm title . "AutoRun"
}

Tk_AutoRun_Init_MainMenu;

frame .ar
listbox .ar.list -font fixed -width 80 -height 8
frame .ar.watch
label .ar.watch.noch -text "noch "
label .ar.watch.timeleft -textvariable watchdog(left)
label .ar.watch.von -text " von "
entry .ar.watch.maxtime -width 4 -background pink -textvariable watchdog(maxtime)
label .ar.watch.s -text " Sekunden"
text .ar.log -font fixed -width 80 -height $logheight

pack .ar -fill both
pack .ar.list
pack .ar.watch
pack .ar.watch.noch -side left
pack .ar.watch.timeleft -side left
pack .ar.watch.von -side left
pack .ar.watch.maxtime -side left
pack .ar.watch.s -side left
pack .ar.log


proc remove_ar {{not_again ""}} { 
	global watchdog logfile
	if {[file exists $watchdog(running)]} {
		set fp [open $watchdog(running) r]
		gets $fp line;  #test
		close $fp
		
		scan $line "%d" pid
		
		set fp [open $logfile a]
		puts $fp ""
		
		if {[catch {exec kill $pid}]} {
			puts $fp "kill PID $pid failed"
			if {[catch {exec kill -9 $pid}]} {
				puts $fp "kill -KILL PID $pid failed"
			}
		}
		
		if {$not_again==""} {
			set gpib_killed 1
				
			while {$gpib_killed} {
				catch {exec ~eminus/bin/gpib stop}
				after 2000
					
				set gpib_killed 0
				
				set module_file [open "/proc/modules" r]
				while {![eof $module_file]} {
					gets $module_file line
					scan $line "%s %*s %s" module_name module_use_count
					if {$module_name=="gpib_drv"} {
						if {$module_use_count > 0} {
								puts $fp "<gpib_drv> is in use (count: $module_use_count)"
								puts "<gpib_drv> is in use (count: $module_use_count)"
								after 5000
								set gpib_killed 1
								if {[catch {exec kill -9 $pid}]} {
									puts $fp "kill -KILL PID $pid failed"
								}
						} else {
							puts $fp "<gpib_drv> is still there !?!"
							puts "<gpib_drv> is still there !?!"
						}
					} 
				}
				close $module_file
			}
		}
		
		if {[file exists $watchdog(file)]} {
			if {[catch {exec rm $watchdog(file)}]} {
				puts $fp "rm $watchdog(file) failed"
			}
		}
		if {[catch {exec rm $watchdog(running)}]} {
			puts $fp "rm $watchdog(running) failed"
		}
		
		
		puts $fp "####\n#### AR-Process killed ([clock format [clock seconds] -format "%d.%m.%y %H:%M:%S"])\n####\n"
		close $fp
	}
	
	if {$not_again==""} { 
		catch {exec ~eminus/bin/gpib start}
		after 2000
		exec nohup tclsh armain.tcl >>$logfile 2>>$logfile &
	}
}

proc tick {} {
	global .ar.arlist list
	global varfile varfile_modified;
	global listfile listfile_modified;
	global logfile logfile_modified logheight;
	global watchdog
	
	after 1000 tick

	if {[file exists $watchdog(file)]} {
		set watchdog(left) [expr $watchdog(maxtime) - ([clock seconds] - [file mtime $watchdog(file)])] 
		if {$watchdog(left) < 0} {
		remove_ar;
		file delete $watchdog(file)
		file delete $watchdog(running)
		after 1000
		#exec nohup tclsh armain.tcl >>$logfile 2>>$logfile &
		}
	}

# Nachsehen, ob sich die AR-Liste gendert hat	
	if {[file exists $listfile]} {
		if {[file mtime $listfile] > $listfile_modified} {
			set listfile_modified [file mtime $listfile]
			source $listfile
		}
	}

# Neues Variablenfile vorhanden?
	if {[file exists $varfile]} {
		if {[file mtime $varfile] > $varfile_modified} {
			set varfile_modified [file mtime $varfile]
			source $varfile
		}
	}
	
# nderungen des Logfiles am Bildschirm anzeigen
	if {[file exists $logfile]} {
		if {[file mtime $logfile] > $logfile_modified} {
			set logfile_modified [file mtime $logfile]
			.ar.log delete 0.0 end	
			.ar.log insert end [exec tail -$logheight $logfile]
		}
	}

	while {[.ar.list size]>0} {
		.ar.list delete end
	}

	.ar.list insert end [format "%15s: %5s %5s %5s %5s" Sample Soll Ist Cool Count]
	
	foreach i $list(list) {
		if {![info exists list($i:cool)]} {
			set list($i:cool) 0
		}

		if {![info exists list($i:soll)]} {
			set list($i:soll) 60
		}

		if {[info exists list($i:ist)]} {
			.ar.list insert end [format "%15s: %5d %5d %5d %5d" \
			$i $list($i:soll) \
			[expr $list($i:ist)-[clock seconds]] \
			$list($i:cool) $list($i:count)]
		}
	}

  
	update idletasks;
}

remove_ar;

tick;
