#!/usr/X11R6/bin/wish
#
# This script generates a counter with start and stop buttons.

#load [info library]/libtclmod.so
#load [info library]/libgpib.so
#source ~/subs/arsubs.tcl

set varfile "/home/leiderer/eminus/ar/armain.vars"
set varfile_modified 0

set listfile "/home/leiderer/eminus/ar/armain.list"
set listfile_modified 0

set logfile "/home/leiderer/eminus/ar/armain.log"
set logfile_modified 0
set logheight 10

set bigfont "-*-times-medium-r-*-*-25-*-*-*-*-*-*-*"
set midfont "-*-helvetica-medium-r-*-*-10-*-*-*-*-*-*-*"

set mux4_modified 0
set mux5_modified 0
set koax_modified 0

proc Tk_Relais_Init_MainMenu {} {
  frame .menu  -relief raised -borderwidth 2
    menubutton .menu.file    -text "File"    -underline 0 -menu .menu.file.items
      menu .menu.file.items
		.menu.file.items add separator
        .menu.file.items add command -label "Info" -underline 0 -command {puts "\n  1998, by J\"urgen Leib, Andi and Schuh"}
        .menu.file.items add separator
        .menu.file.items add command -label "Beenden" -underline 0 -command {destroy .}

    global PLM

  # Binding of Menu ...
  tk_menuBar menu menu.file

  pack .menu -fill x -padx 1 -pady 1
  pack .menu.file -side left
  
  wm title . "AutoRun"
}

Tk_Relais_Init_MainMenu;

frame .ar
listbox .ar.list -font fixed -width 80 -height 8
text .ar.log -font fixed -width 80 -height $logheight

pack .ar -fill both
pack .ar.list
pack .ar.log


proc tick {} {
	global .ar.arlist list
	global varfile varfile_modified;
	global listfile listfile_modified;
	global logfile logfile_modified logheight;
	
	after 5000 tick

# Nachsehen, ob sich die AR-Liste gendert hat	
	if {[file exists $listfile]} {
		if {[file mtime $listfile] > $listfile_modified} {
			set listfile_modified [file mtime $listfile]
			source $listfile
		}
	}

# Neues Variablenfile vorhanden?
	if {[file exists $varfile]} {
		if {[file mtime $varfile] > $varfile_modified} {
			set varfile_modified [file mtime $varfile]
			source $varfile
		}
	}
	
# nderungen des Logfiles am Bildschirm anzeigen
	if {[file exists $logfile]} {
		if {[file mtime $logfile] > $logfile_modified} {
			set logfile_modified [file mtime $logfile]
			.ar.log delete 0.0 end	
			.ar.log insert end [exec tail -$logheight $logfile]
		}
	}

	while {[.ar.list size]>0} {
		.ar.list delete end
	}

	.ar.list insert end [format "%15s: %5s %5s %5s %5s" Sample Soll Ist Cool Count]
	
	foreach i $list(list) {
		if {![info exists list($i:cool)]} {
			set list($i:cool) 0
		}

		if {[info exists list($i:ist)]} {
			.ar.list insert end [format "%15s: %5d %5d %5d %5d" \
			$i $list($i:soll) \
			[expr $list($i:ist)-[clock seconds]] \
			$list($i:cool) $list($i:count)]
		}
	}

  
	update idletasks;
}

tick;
