#!/usr/local/bin/artclsh

load [info library]/libtclmod.so

source "~eminus/subs/arsubs.tcl"

set RUNNING_FILE "[Exp_Config_Dir]/locks/AR.running"
set TEMPERATURE_FILE "[Exp_Config_Dir]/locks/read.temp"

proc check_temp {} {
	global TEMPERATURE_FILE
	if {[file exists $TEMPERATURE_FILE]} {
		puts "\n### reading temperature"
		queue temp_readout
		file delete $TEMPERATURE_FILE
	}
}
	
set wait 5
set list(cool) [clock seconds]
set next ""

	if {[file exists $RUNNING_FILE]} {
		puts "ERROR: armain.tcl is already running!"
		exit
	}

	set fp [open $RUNNING_FILE w]
	puts $fp [pid]
	close $fp
	

	while {1} {

		if {[file exists "armain.stop"]} {
			file delete $RUNNING_FILE
			file delete armain.stop
			exit
		}
	
		# Die aktuellen AutoRun-Variablen einlesen	
		if {[file exists "armain.vars"]} {
			source armain.vars
		}

		# Die AutoRun-Liste einlesen	
		if {[file exists "armain.list"]} {
			source armain.list
		} else {
			puts "ERROR: no file 'armain.list'"
		}
		

		set last $next			
		set next  ""
		set count 1000000000

		foreach p $list(list) {
			
			# Die Felder ist und count neu dazugekommener Proben initialisieren
			if {![info exists list($p:ist)]} {
				set list($p:ist) [expr [clock seconds] ]
				set list($p:count) 0
			}
			
			if {![info exists list($p:soll)]} {
				set list($p:soll) 10
			}
			
			if {[expr $list($p:ist) - [clock seconds]] <= 0} {
				if {$list($p:count)<$count} {
					set next $p; set count $list($p:count)
				}
			}
		}
		
		# falls die Auskhlzeit noch nicht abgelaufen ist wieder schlafen
		
		if {[expr $list(cool) - [clock seconds]] > 0} {
			# puts "coolsleep [expr ($list(cool) - [clock seconds])]"
			check_temp
			after [expr ($list(cool) - [clock seconds])*1000]
			continue
		}

		if {$next!=""} {
			puts "\n*** $next #$list($next:count) ([clock format [clock seconds] -format "%d.%m.%y %H:%M:%S"])"
			set list($next:ist) [clock seconds]

			if {[file exists $next]} {
				queue $next
				set list($next:ist) [expr $list($next:ist) + $list($next:soll)]
				incr list($next:count)
				
				if {[info exists list($next:cool)]} {
					set list(cool) [expr [clock seconds] + $list($next:cool)]
				} else {
					set list(cool) [clock seconds]
				}
				
			} else {
				puts "ERROR: no scriptfile '$next'"
				set list(cool) [clock seconds]
			}
			
			set varfp [open "armain.vars" w]
				
			foreach p $list(list) {
				puts $varfp "set list($p:soll) $list($p:soll); set list($p:ist) $list($p:ist); set list($p:count) $list($p:count)"
			}
			close $varfp
			check_temp
		} else {
			check_temp
			# Maximal 1 Minute Wartezeit
			set minist [expr [clock seconds] + 60]
			
			# Probe mit der kuerzesten Wartezeit suchen
			foreach p $list(list) {
				if {$list($p:ist) < $minist} {
				   set minist $list($p:ist)
				}
			}
			
			if {[expr $minist-[clock seconds]] > 0} {
				# und warten
				# puts "sleeping for [expr $minist-[clock seconds]] s"
				after [expr ($minist-[clock seconds])*1000]
			}
		}
		
	}
