#!/usr/local/bin/tclsh

		source network_meas.data;

		set filament_status(basename) "$network_meas(month)[]d$network_meas(number)"
		set filament_status(prefix) "data/microwave/mw$filament_status(basename)/filaments"
		
		if {![file exists "$filament_status(prefix)"]} {
			puts "making directory \"$filament_status(prefix)\""
			file mkdir "$filament_status(prefix)"	
		}
		
		set file_number [status read filament_status.s0]
		
		set filament_status(postfix) $filament_status(basename).[format "%05d" $file_number]
		set filament_status(uname) filu$filament_status(postfix)
		set filament_status(duname) Dfilu$filament_status(postfix)
		set filament_status(iname) fili$filament_status(postfix)
		set filament_status(diname) Dfili$filament_status(postfix)
		set filament_status(name) fil$filament_status(postfix)
		set filament_status(dname) fil$filament_status(postfix)
		
		set olddir [pwd]
		
		cd $filament_status(prefix)

		puts -nonewline "reading out TDS210 ..."		
		tek read TDS210 ch1 $filament_status(uname)
		exec atod filu$filament_status(postfix)
		tek read TDS210 ch2 $filament_status(iname)
		exec atod fili$filament_status(postfix)
		puts "done"

		exec paste Dfilu$filament_status(postfix) Dfili$filament_status(postfix) | cut -d " " -f "1 2 4" > Dfil$filament_status(postfix)
		file delete filu$filament_status(postfix)
		file delete fili$filament_status(postfix)
		file delete Dfilu$filament_status(postfix)
		file delete Dfili$filament_status(postfix)
		cd $olddir
		
		incr file_number
		status write filament_status.s0 $file_number

