#!/usr/bin/tclsh

load [info library]/libtclmod.so
source ~eminus/subs/arsubs.tcl

set U_Halt_Threshold 0

proc U_Halt_Negativ {} {
	dac set 1 0V
	ieee write LTC10 "SPID2,0,0,0,100,0,0;"
}

proc U_Halt_Start {} {
	global U_Halt_Threshold
	dac set 1 $U_Halt_Threshold[]V
	ieee write LTC10 "SPID2,0,0,0,0.001,0,0;"
}

proc Pulse_Stop {} {
	status write [Exp_Config_Dir]/params/fil_puls.s0 "stop 0V 0ms 0s"
}

proc Pulse_Start {{Pulse_Amplitude "1.5V"} {Pulse_Duration "40ms"}} {
	status write [Exp_Config_Dir]/params/fil_puls.s0 "puls $Pulse_Amplitude $Pulse_Duration 2s"
}

set U_Halt_List "1.5"

#Pulse_Stop
#U_Halt_Negativ
#sleep 100

foreach U_Halt $U_Halt_List {
	puts "Starting -> $U_Halt V"
	U_Halt_Start
	Pulse_Start 1.5V 40ms
	
	dac sweep 1 [expr $U_Halt+$U_Halt_Threshold][]V 1800
	sleep 1800
	puts "Sweep ready, waiting ...."
	sleep 200
	puts "Pulsstop"
	Pulse_Stop
	sleep 300
	puts "Removing Electrons"
	U_Halt_Negativ
	sleep 900
	puts ""
}
