#!/usr/bin/tclsh

load [info library]/libtclmod.so
source ~eminus/subs/arsubs.tcl

set U_Halt_Threshold -2
set U_Halt_Zero -4.863

proc check_U_Halt {} {
	global U_Halt_Zero U_Halt_Minus
	dout set 2
	dout clear 8
	set U_Halt_Zero [kscan select K2000 U_Halt]
	dout set 8
	set U_Halt_Minus [kscan select K2000 U_Halt]

	puts "0: $U_Halt_Zero"
	puts "-: $U_Halt_Minus"
}

proc data_separator {} {
	exec touch [Exp_Config_Dir]/flags/network_meas.new_section
}

proc U_Halt_Negativ {} {
	dac set 1 0V
	dout clear 2
}

proc U_Halt_Start {} {
	global U_Halt_Threshold U_Halt_Zero
	dac set 1 0V
	dout set 8
	dac set 1 [expr $U_Halt_Threshold-$U_Halt_Zero]V
	dout set 2
}

proc Pulse_Stop {} {
	status write [Exp_Config_Dir]/params/fil_puls.s0 "stop 0V 0ms 0s"
}

proc Pulse_Start {{Pulse_Amplitude "1.4V"} {Pulse_Duration "40ms"}} {
	status write [Exp_Config_Dir]/params/fil_puls.s0 "puls $Pulse_Amplitude $Pulse_Duration 3s"
}

set U_Halt_List "-0.3 -0.2 -0.1 0.0 0.1 0.2 0.3 0.4 0.5 0.6 0.7 0.8 0.9 1.0 1.5 2.0"
#2.25 2.5 2.75 3.0 3.5 4.0 5.0 6.0 7.0"

#Pulse_Stop
#U_Halt_Negativ
#sleep 100

#check_U_Halt

foreach U_Halt $U_Halt_List {
	data_separator
	puts "starting"
	Pulse_Stop
	U_Halt_Start
	sleep 60
	dout set 4
	puts "sweeping -> $U_Halt V"
	
	Pulse_Start 1.4V 40ms

	if {[expr $U_Halt-$U_Halt_Zero] > 10} {
		puts "U_Halt $U_Halt is out of range!"
	} else {
	set dacval [expr $U_Halt-$U_Halt_Zero]
	}
	puts " DAC1 -> $dacval V"
	dac sweep 1 $dacval[]V 1800
	sleep 1800
	puts "Sweep ready, waiting ...."
	sleep 300
	puts "Pulsstop"
	Pulse_Stop
	sleep 300
	puts "Removing Electrons"
	U_Halt_Negativ
	sleep 150
	puts "Pulsing ..."
	Pulse_Start 1.4V 40ms
	sleep 15
	Pulse_Stop
	puts "Ready and waiting ..."
	sleep 150
	puts ""
}
data_separator

