#!/usr/bin/tclsh

load [info library]/libtclmod.so
source ~eminus/subs/arsubs.tcl

set U_Halt_Threshold -1
set U_Halt_Zero -4.863

proc check_U_Halt {} {
	global U_Halt_Zero U_Halt_Minus
	dout set 2
	dout clear 8
	set U_Halt_Zero [kscan select K2000 U_Halt]
	dout set 8
	set U_Halt_Minus [kscan select K2000 U_Halt]

	puts "0: $U_Halt_Zero"
	puts "-: $U_Halt_Minus"
}

proc data_separator {} {
	exec touch [Exp_Config_Dir]/flags/network_meas.new_section
}

proc U_Halt_Negativ {} {
	dac set 1 0V
	dout clear 2
}

proc U_Halt_Start {} {
	global U_Halt_Threshold U_Halt_Zero
	dac set 1 0V
	dout set 8
	dac set 1 [expr $U_Halt_Threshold-$U_Halt_Zero]V
	dout set 2
}

proc Pulse_Stop {} {
	status write [Exp_Config_Dir]/params/fil_puls.s0 "stop 0V 0ms 0s"
}

proc Pulse_Start {{Pulse_Amplitude "1.4V"} {Pulse_Duration "40ms"}} {
	status write [Exp_Config_Dir]/params/fil_puls.s0 "puls $Pulse_Amplitude $Pulse_Duration 3s"
}

set pulsetime_list "10ms 20ms 30ms 40ms"
set pulseamp_list "0.5V 0.75V 1.0V 1.25V"

foreach pulsetime $pulsetime_list {
	foreach pulseamp $pulseamp_list {
		data_separator
		puts "starting"
		dout set 2
		dout clear 8
		dac set 1 9V	
		Pulse_Start $pulseamp $pulsetime
		sleep 1500
		puts "Pulsstop"
		Pulse_Stop
		sleep 150
		puts "Removing Electrons"
		U_Halt_Negativ
		sleep 150
	}
}
data_separator

