#!/usr/bin/tclsh

load [info library]/libtclmod.so
source ~eminus/subs/arsubs.tcl

set U_Halt_Threshold -0.5
set U_Halt_Zero -4.923

proc check_U_Halt {} {
	global U_Halt_Zero U_Halt_Minus
	dout set 2
	dout clear 8
	set U_Halt_Zero [kscan select K2000 U_Halt]
	dout set 8
	set U_Halt_Minus [kscan select K2000 U_Halt]

	puts "0: $U_Halt_Zero"
	puts "-: $U_Halt_Minus"
}

proc data_separator {} {
	exec touch [Exp_Config_Dir]/flags/network_meas.new_section
}

proc U_Halt_Negativ {} {
	dac set 1 0V
	dout clear 2
}

proc U_Halt_Start {} {
	global U_Halt_Threshold U_Halt_Zero
	dac set 1 0V
	dout set 8
	dac set 1 [expr $U_Halt_Threshold-$U_Halt_Zero]V
	dout set 2
}

proc Pulse_Stop {} {
	status write [Exp_Config_Dir]/params/fil_puls.s0 "stop 0V 0ms 0s"
}

proc Pulse_Start {{Pulse_Amplitude "1.4V"} {Pulse_Duration "40ms"}} {
	status write [Exp_Config_Dir]/params/fil_puls.s0 "puls $Pulse_Amplitude $Pulse_Duration 3s"
}

foreach db "-25 -20 -15 -10 -5 0" {

	set fp [open "[Exp_Config_Dir]/flags/network_meas.parameters" w]
	puts $fp "set network_meas(power) $db"
	close $fp
	
	data_separator

	Pulse_Start 1.5V 40ms
	U_Halt_Start
	
	set U_Halt -0.1
	puts "sweep to startval"
	dac sweep 1 [expr $U_Halt-($U_Halt_Zero)]V 600s
	sleep 900


	while {$U_Halt < 0.5} {
		set U_Halt [expr $U_Halt+0.05]
		puts "sweep to $U_Halt"
		dac sweep 1 [expr $U_Halt-($U_Halt_Zero)]V 300s
		sleep 600
	}

	puts "Pulsstop"
	Pulse_Stop
	data_separator
	puts "Removing Electrons"
	U_Halt_Negativ
	sleep 600
}
