#!/usr/bin/tclsh

load [info library]/libtclmod.so
source ~eminus/subs/arsubs.tcl

set U_Halt_Threshold 1.9

proc U_Halt_Negativ {} {
	dac set 1 0V
	dout clear 2
}

proc U_Halt_Start {} {
	global U_Halt_Threshold
	dac set 1 $U_Halt_Threshold[]V
	dout set 2
}

proc Pulse_Stop {} {
	status write [Exp_Config_Dir]/params/fil_puls.s0 "stop 0V 0ms 0s"
}

proc Pulse_Start {{Pulse_Amplitude "1.4V"} {Pulse_Duration "40ms"}} {
	status write [Exp_Config_Dir]/params/fil_puls.s0 "puls $Pulse_Amplitude $Pulse_Duration 3s"
}

dac set 1 0V

set Wait_List "60 120 150 180 210 240 270 300 400 500 600 700 800 900 1000 1100 1200"

foreach Wait_Time $Wait_List {
	puts "attracting field with pulses ..."
	U_Halt_Start
	Pulse_Start 1.0V 50ms
	dac sweep 1 [expr $U_Halt_Threshold+1.7]V 60
	sleep 60
	puts "stop pulsing ..."
	Pulse_Stop
	sleep 60
	puts "removing electrons ..."
	U_Halt_Negativ
	sleep $Wait_Time
	puts "trying to get electrons back ..."
	U_Halt_Start
	dac set 1 [expr $U_Halt_Threshold+1.7]V
	sleep 1200
}
